// Coppia.java

package dBattNav.dCoppia;

/* - [ Layout del piano ] -------------------------------------------------- *
 *                                                                           *
 *    ^                               x > 0                                  *
 *  y |                               y > 0                                  *
 *   .|_|_|_|_|_|_|_|_|_|_|_|                                                *
 *   .|_|_|_|_|_|_|_|_|_|_|_|                                                *
 *   9|_|_|_|_|_|_|_|_|_|_|_|                                                *
 *   8|_|_|_|_|_|_|_|_|_|_|_|                                                *
 *   7|_|_|_|_|_|_|_|_|_|_|_|                                                *
 *   6|_|_|_|_|_|_|_|_|_|_|_|                                                *
 *   5|_|_|_|_|_|_|_|_|_|_|_|                                                *
 *   4|_|_|_|_|_|_|_|_|_|_|_|                                                *
 *   3|_|_|_|_|_|_|_|_|_|_|_|                                                *
 *   2|_|_|_|_|_|_|_|_|_|_|_|                                                *
 *   1| | | | | | | | | | | |                                                *
 *  --+----------------------->                                              *
 *   0|1 2 3 4 5 6 7 8 9 ...  x                                              *
 *                                                                           *
 * ------------------------------------------------------------------------- */

/** classe Coppia per la gestione di un punto nel piano
@see dBattNav.dNave.Nave
@see dBattNav.dNave.Portaerei */
public class Coppia {
    private int x,y;    //coordinate di un punto

    /** costruttore di inizializzazione
    @param x coordinata x del punto
    @param y coordinata y del punto
    */
    public Coppia (int X,int Y) {
        x=X;
        y=Y;
    }//Coppia

    /** getX restituisce la coordinata x
    @return x
    */
    public int getX () {
        return x;
    }//getX

    /** getY restituisce la coordinata y
    @return y
    */
    public int getY () {
        return y;
    }//getY

    /** getX imposta la coordinata x
    @param x
    */
    public void setX (int X) {
        x=X;
    }//getX

    /** getY imposta la coordinata y
    @param y
    */
    public void setY (int Y) {
        y=Y;
    }//getY

    /** toString
    @return coordinate
    */
    public String toString () {
        return "Coordinate del punto: ("+x+"; "+y+")";
    }//toString
}//Coppia
