// TestBattNav.java

package dTest;

import  java.util.Random;

import  dBattNav.BattNav;
import  dBattNav.dCoppia.Coppia;
import  dBattNav.dNave.Nave;
import  dBattNav.dNave.Portaerei;
import  dUtil.Console;

/** classe per il test della classe BattNav
@see BattNav */
public class TestBattNav {
    public static void main (String Args[]) {
        if (Args.length!=2)                     //controllo numero argomenti
            printHelp();                        //stampa un messaggio d'aiuto
        else {
            int ng=Integer.parseInt(Args[0]);   //numero di giocatori
            int nn=Integer.parseInt(Args[1]);   //numero di navi

            if (ng<1||ng>4||nn<1) {             //controllo valori dei parametri
                printHelp();                    //stampa un messaggio d'aiuto
                return;
            }//if

            printCredits();                     //stampa intestazione
            Console.pause();

            playGame(ng,nn);                    //inizio del gioco
        }//else
    }//main

    /** playGame svolge le funzioni necessarie per lo svolgimento del gioco
    */
    private static void playGame (int ng,int nn) {
        Nave array_navi[][]=new Nave[ng][nn];   //le flotte dei giocatori
        BattNav campo[]=new BattNav[2];         //campi di battaglia
        String nomi[]={"",""};                  //nomi dei giocatori
        Random r=new Random();                  //generatore di numeri casuali
        int x,y,l;                              //var temporanee per la lettura dei dati della flotta

        for (int g=0;g<(ng>1?2:1);g++) {        //per ogni giocatore (1-2)
            nomi[g]=(ng+g>3?"PC"+(g+1):         //lettura/generazione del nome dei giocatori
                     Console.readLine("Inserisci il tuo nome: "));

            array_navi[g]=new Nave[nn];         //array contente le navi della flotta
            array_navi[g][0]=allocaPortaerei(ng,g,nomi,r);  //allocazione della portaerei
            allocaNavi(ng,nn,g,nomi,r,array_navi);          //allocazione delle navi
            campo[g]=new BattNav(array_navi[g]);//allocazione del campo di gioco

            System.out.println();               //stampa del campo creato
            campo[g].stampaCampo();
            Console.pause();
        }//for

        int g=0;                                //numero giocatore corrente
        boolean m[][]=new boolean[25][25];      //matrice dei punti colpiti dal calcolatore
        String ris="";                          //risultato del colpo
        do {
            ris=leggiColpo(ng,g,nomi,campo,r,m);//lettura/generazione colpo e sua applicazione

            if (ng==1)                          //stampa dei campi
                campo[0].stampaCampo();
            else {
                StringBuffer stato1[]=campo[0].getCampo();
                StringBuffer stato2[]=campo[1].getCampo();
                System.out.println("\n  Giocatore 1               \t  Giocatore 2");
                for (int i=0;i<28;i++)
                    System.out.println(stato1[i]+"\t"+stato2[i]);
            }//else
            Console.pause();

            //cambio turno
            if (ng==1)                          //modalita' ad un giocatore
                g=0;
            else                                //modalita' a 2 giocatori
                g=(g==0?1:0);
        }while(ris.equals("flotta ko")==false);
        Console.printHeader("Hai vinto giocatore "+(ng==1?1:2-g)+": "+nomi[(ng==1?0:1-g)]+"!!!!!!");
    }//playGame

    /** allocaPortaerei legge/genera le coordinate della portaerei e la alloca
    */
    private static Portaerei allocaPortaerei (int ng,int g,String nomi[],Random r) {
        int x,y,l;                          //var temporanee per la lettura dei dati della flotta
        if (ng+g>3) {                       //lettura coordinate della portaerei e sua allocazione
            Console.printHeader("Generazione dati della portaerei per "+nomi[g]);
            l=r.nextInt(4)+1;
            for (x=r.nextInt(25)+1;x<1||x>26-l;x=r.nextInt(25)+1);
            for (y=r.nextInt(25)+1;y<1||y>24;y=r.nextInt(25)+1);
            Console.printSubHeader("l="+l+"\n"+"- x="+x+"\n"+"- y="+y);
        }//if
        else {
            Console.printHeader("Lettura dati della portaerei per "+nomi[g]);
            for (l=Console.readInt("- Inserisci lunghezza: ");l<1||l>4;l=Console.readInt("-\n- La lunghezza deve essere > 0 e <=4!\n- Inserisci lunghezza: "));
            for (x=Console.readInt("- Inserisci x: ");x<1||x>26-l;x=Console.readInt("-\n- La nave non rientra nel campo!\n- Inserisci x: "));
            for (y=Console.readInt("- Inserisci y: ");y<1||y>24;y=Console.readInt("-\n- La nave non rientra nel campo!\n- Inserisci y: "));
        }//else
        return new Portaerei(new Coppia(x,y),l);
    }//allocaPortaerei

    /** allocaNavi legge/genera le coordinate delle navi e le alloca
    */
    private static void allocaNavi (int ng,int nn,int g,String nomi[],Random r,Nave array_navi[][]) {
        int x,y,l;                          //var temporanee per la lettura dei dati della flotta
        if (ng+g>3) {                       //lettura coordinate delle navi e loro allocazione
            Console.printHeader("Generazione dati delle navi per "+nomi[g]);
            for (int i=1;i<nn;i++) {
                do {                        //controllo sovrapposizione delle navi
                    l=r.nextInt(4)+1;
                    for (x=r.nextInt(25)+1;x<1||x>26-l;x=r.nextInt(25)+1);
                    for (y=r.nextInt(25)+1;y<1||y>25;y=r.nextInt(25)+1);
                }while (checkNavi(array_navi[g],i,x,y,l));
                Console.printSubHeader("Nave #"+(i+1)+":\n- l="+l+"\n"+"- x="+x+"\n"+"- y="+y);
                array_navi[g][i]=new Nave(new Coppia(x,y),l);
            }//for
        }//if
        else {
            Console.printHeader("Lettura dati delle navi per "+nomi[g]);
            for (int i=1;i<nn;i++) {
                boolean checkSovr=false;
                do {                        //controllo sovrapposizione delle navi
                    if (checkSovr==true)
                        System.out.println("- Navi in sovrapposizione, cambiare parametri...");
                    for (l=Console.readInt("-\n- Nave # "+(i+1)+":\n- Inserisci lunghezza: ");l<1||l>4;l=Console.readInt("-\n- La lunghezza deve essere > 0 e <=4!\n- Inserisci lunghezza: "));
                    for (x=Console.readInt("- Inserisci x: ");x<1||x>26-l;x=Console.readInt("-\n- La nave non rientra nel campo!\n- Inserisci x: "));
                    for (y=Console.readInt("- Inserisci y: ");y<1||y>25;y=Console.readInt("-\n- La nave non rientra nel campo!\n- Inserisci y: "));
                }while (checkSovr=checkNavi(array_navi[g],i,x,y,l));
                Console.printSubHeader("");
                array_navi[g][i]=new Nave(new Coppia(x,y),l);
            }//for
        }//else
    }//allocaNavi

    /** leggiColpo legge/genera un colpo e lo applica al campo restituendo il risultato
    */
    private static String leggiColpo (int ng,int g,String nomi[],BattNav campo[],Random r,boolean m[][]) {
        int x,y,l;                          //var temporanee per la lettura dei dati della flotta
        Console.printHeader("Lettura colpo per il giocatore "+(g+1)+": "+nomi[g]);
        if (ng+g>3) {                       //lettura/generazione colpo
            do {                            //controllo della ripetizione dei colpi
                for (x=r.nextInt(25)+1;x<1||x>25;x=r.nextInt(25)+1);
                for (y=r.nextInt(25)+1;y<1||y>25;y=r.nextInt(25)+1);
            }while (checkColpo(x,y,m));
            System.out.println("- Coordinate colpo: X="+x+"\tY="+y);
        }//if
        else {
            for (x=Console.readInt("- Inserisci x: ");x<1||x>25;x=Console.readInt("-\n- La nave non rientra nel campo!\n- Inserisci x: "));
            for (y=Console.readInt("- Inserisci y: ");y<1||y>25;y=Console.readInt("-\n- La nave non rientra nel campo!\n- Inserisci y: "));
        }//else
        String ris=campo[(ng==1?0:1-g)].fuoco(new Coppia(x,y));
        Console.printSubHeader("Esito del colpo: ("+ris+")\n\n"+campo[(ng==1?0:1-g)]);
        return ris;
    }//leggiColpo

    /** checkNavi controlla che una nave appena generata non si sovrapponga a quelle esistenti
    */
    private static boolean checkNavi (Nave navi[],int n,int xn,int yn,int ln) {
        int x,y,l;
        for (int i=0;i<n;i++) {
            x=navi[i].getX();
            y=navi[i].getY();
            l=navi[i].getL();
            //controllo collisione con la pista della portaerei
            if (i==0&&(yn==y+1)&&(x>=xn&&x<xn+ln))
                return true;
            //controllo collisione
            if ((yn==y)&&((xn>=x&&xn<x+l)||(x>=xn&&x<xn+ln)))
                return true;
        }//for
        return false;
    }//checkNavi

    /** checkColpo controlla che un colpo non venga ripetuto nello stesso punto
    */
    private static boolean checkColpo(int x,int y,boolean m[][]) {
        if (m[x-1][y-1])
            return true;
        else
            m[x-1][y-1]=true;
        return false;
    }//checkColpo

    /** print_help stampa il modo d'uso del programma
    */
    private static void printHelp () {
        System.out.println("Numero giocatori errato, o numero navi troppo piccolo!\n\n");
        System.out.println("USO: TestBattNav giocatori n_navi");
        System.out.println("\ngiocatori={\n\t1 = persona singola,\n\t2 = persona vs persona,");
        System.out.println("\t3 = persona vs pc,\n\t4 = pc vs pc (demo)\n\t}\nn_navi>=1");
    }//print_help

    /** print_credits stampa delle info sul gioco
    */
    private static void printCredits () {
        System.out.println("\n-------------------------------------------------------------------");
        System.out.println("- Alberto Cavalin, Mauro Malvestio, Renato Guarino                -");
        System.out.println("- Battaglia Navale in Java                         A.A. 2002/2003 -");
        System.out.println("-------------------------------------------------------------------");
    }//print_credits
}//TestBattNav
