// BattNav.java

package dBattNav;

import  dBattNav.dNave.Nave;
import  dBattNav.dNave.Portaerei;
import  dBattNav.dCoppia.Coppia;
import  dUtil.Console;

/** classe BattNav per la gestione delle navi in un campo
@see Coppia
@see Nave
@see Portaerei */
public class BattNav {
    private Nave navi[];              //array contente le navi della flotta

    /** costruttore di inizializzazione
    @param array_navi array contente le navi della flotta
    */
    public BattNav (Nave array_navi[]) {
        navi=array_navi;
    }//Nave

    /** fuoco ritorna l'esito di un colpo
    @param x coordinata x del colpo
    @param y coordinata y del colpo
    @return String esito <acqua|affondato|colpito|flotta ko>
    */
    public String fuoco (Coppia c) {
        for (int i=0;i<navi.length;i++) {
            String ris;               //stringa del risultato

            if (i==0)                 //il primo elemento e' di tipo Portaerei
                ris=((Portaerei) navi[i]).fuoco(c);
            else                      //gli altri elementi sono di tipo Nave
                ris=navi[i].fuoco(c);            

            if(ris.equals("colpito")) //elaborazione risultato
                return ris;

            if(ris.equals("affondato")){
                for (int j=0;j<navi.length;j++) {
                    if (j==0){        //il primo elemento e' di tipo Portaerei
                        if(((Portaerei) navi[j]).controllo()==false)
                            return "affondato";
                    }//if                        
                    else              //gli altri elementi sono di tipo Nave
                        if(navi[j].controllo()==false)
                            return "affondato";
                }//for
                return "flotta ko";    
            }//if                   
        }//for
        return "acqua";
    }//fuoco

    /** Ritorna il campo stampabile con lo stato delle navi
    @return campo stampabile con lo stato delle navi
    */
    public StringBuffer [] getCampo () {
        StringBuffer stato[]=new StringBuffer[28];
        stato[0]=new StringBuffer(" .-------------------------.");
        for (int i=1;i<26;i++) {
            stato[i]=new StringBuffer("n|                         |");
            stato[i].setCharAt(0,String.valueOf((26-i)%10).charAt(0));
        }//for
        stato[26]=new StringBuffer(" `-------------------------'");
        stato[27]=new StringBuffer("  1234567890123456789012345 ");

        for (int i=0;i<navi.length;i++) {
            boolean status[]=navi[i].getStatus();
            int x=navi[i].getX(),
                y=navi[i].getY(),
                l=status.length;
            if (i==0) {   //il primo elemento e' di tipo Portaerei
                //controllo pista
                String s;
                if (status[0])
                    s=new String("x");
                else
                    s=new String("o");
                stato[25-y].setCharAt(x+1,s.charAt(0));

                //controllo del resto della portaerei
                for (int j=x+1;j<x+1+l-1;j++) {
                    if (status[j-(x+1)+1])
                        s=new String("x");
                    else
                        s=new String("o");
                    stato[26-y].setCharAt(j,s.charAt(0));
                }//for
            }//if
            else {        //gli altri elementi sono di tipo Nave
                for (int j=x+1;j<x+1+l;j++) {
                    String s;
                    if (status[j-(x+1)])
                        s=new String("x");
                    else
                        s=new String("o");
                    stato[26-y].setCharAt(j,s.charAt(0));
                }//for
            }//else
        }//for
        return stato;
    }//getCampo

    /** Stampa il campo con lo stato delle navi
    */
    public void stampaCampo () {
        StringBuffer stato[]=getCampo();
        for (int i=0;i<28;i++)
            System.out.println(stato[i]);
    }//stampaCampo

    /** toString
    @return stato delle navi
    */
    public String toString () {
        String output_text="";
        for (int i=0;i<navi.length;i++) {
            String ris="";  //stringa del risultato
            if (i==0)   //il primo elemento e' di tipo Portaerei
                ris+=((Portaerei)navi[i]).toString();
            else        //gli altri elementi sono di tipo Nave
                ris+=navi[i].toString();
            output_text+="Nave "+i+" : "+ris+"\n";
        }//for
        return output_text;
    }//toString 
}//BattNav
